#ifndef __D3DAPP_H__
#define __D3DAPP_H__

#include <d3dx9.h>
#include "UTimer.h"
#include "UChar.h"
#include "UCamera.h"
#include "UMap.h"

class D3DApp
{
    // a d3d variables
    LPDIRECT3D9 m_pd3d;
    LPDIRECT3DDEVICE9 m_pd3dDevice;

    // a timer
    UTimer m_timer;

    // a char
    UChar m_char;

    // a camera
    UCamera m_camera;

    // a map
    UMap m_map;
public :
    // constructor
    D3DApp();

    // clean up resources
    void cleanUp();

    // create window
    HRESULT create();

    // set up lights
    void setupLights();

    // run a message loop
    INT run();

    void frameMove( float elapsedTime );

    // render a scene
    void render();

    // message process
    LRESULT msgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );

    // find picked position
    int findPickedPos( int x, int y, D3DXVECTOR3 *vPicked );

};

#endif